OGRE-Next: Ogre::DistanceLodBoxStrategy Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
Ogre::DistanceLodBoxStrategy Class Reference
Core » LOD

Level of detail strategy based on distance from camera to an object's bounding box. More...

`#include <OgreDistanceLodStrategy.h>`

Inheritance diagram for Ogre::DistanceLodBoxStrategy:
[legend]

## Public Member Functions
| DistanceLodBoxStrategy ()
| Default constructor.
Real | getSquaredDepth (const MovableObject *movableObject, const Ogre::Camera *camera) const override
| Get the squared depth from camera to the LOD object.
Public Member Functions inherited from Ogre::DistanceLodStrategyBase
| DistanceLodStrategyBase (const String &name)
| Default constructor.
Real | getBaseValue () const override
| Get the value of the first (highest) level of detail.
bool | isReferenceViewEnabled () const
| Determine if use of the reference view is enabled.
void | lodUpdateImpl (const size_t numNodes, ObjectData t, const Camera *camera, Real bias) const override
void | setReferenceView (Real viewportWidth, Real viewportHeight, Radian fovY)
| Sets the reference view upon which the distances were based.
void | setReferenceViewEnabled (bool value)
| Enables to disables use of the reference view.
Real | transformBias (Real factor) const override
| Transform LOD bias so it only needs to be multiplied by the LOD value.
Real | transformUserValue (Real userValue) const override
| Transform user supplied value to internal value.
Public Member Functions inherited from Ogre::LodStrategy
| LodStrategy (const String &name)
| Constructor accepting name.
virtual | ~LodStrategy ()
| Virtual destructor.
const String & | getName () const
| Get the name of this strategy.
Real | getValue (const MovableObject *movableObject, const Camera *camera) const
| Compute the LOD value for a given movable object relative to a given camera.
Public Member Functions inherited from Ogre::Singleton< DistanceLodBoxStrategy >
| Singleton ()
| ~Singleton ()

## Static Public Member Functions
static DistanceLodBoxStrategy & | getSingleton ()
| Override standard Singleton retrieval.
static DistanceLodBoxStrategy * | getSingletonPtr ()
| Override standard Singleton retrieval.
Static Public Member Functions inherited from Ogre::LodStrategy
static void | lodSet (ObjectData &t, Real lodValues[ARRAY_PACKED_REALS])
Static Public Member Functions inherited from Ogre::Singleton< DistanceLodBoxStrategy >
static DistanceLodBoxStrategy & | getSingleton ()
static DistanceLodBoxStrategy * | getSingletonPtr ()

## Detailed Description

Level of detail strategy based on distance from camera to an object's bounding box.

Remarks
  The purpose of the reference view is to ensure a consistent experience for all users. Monitors of different resolutions and aspect ratios will each have different results for the distance queries.

  It depends on gameplay testing. If all testers had 16:9 monitors and 110° FOV, then that's the value you should enter (to ensure as much as possible the experience stays consistent for all other users who don't have a 16:9 monitor and/or use a different FOV).

  If all your testers had 4:3 monitors, then enter a 4:3 resolution.

  If all your testers had varying resolutions or you just didn't care, then this feature is useless for you and should be disabled (default: disabled).

## Constructor & Destructor Documentation

## ◆ DistanceLodBoxStrategy()

Ogre::DistanceLodBoxStrategy::DistanceLodBoxStrategy | ( |  | ) |

Default constructor.

Referenced by getSingleton(), and getSingletonPtr().

## Member Function Documentation

## ◆ getSingleton()

static DistanceLodBoxStrategy & Ogre::DistanceLodBoxStrategy::getSingleton | ( |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

References DistanceLodBoxStrategy().

## ◆ getSingletonPtr()

static DistanceLodBoxStrategy * Ogre::DistanceLodBoxStrategy::getSingletonPtr | ( |  | ) |
| static

Override standard Singleton retrieval.

Remarks
  Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll.

  This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors.

References DistanceLodBoxStrategy().

Referenced by Ogre::LodConfig::LodConfig().

## ◆ getSquaredDepth()

Real Ogre::DistanceLodBoxStrategy::getSquaredDepth | ( | const MovableObject * | movableObject,
|  | const Ogre::Camera * | camera ) const
| overridevirtual

Get the squared depth from camera to the LOD object.

Implements Ogre::DistanceLodStrategyBase.

The documentation for this class was generated from the following file:

- OgreDistanceLodStrategy.h